<?php

namespace EventPortal\Domain\Team\Handlers;

use Closure;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\Team\Models\Team;
use EventPortal\Domain\User\Models\User;

class AssignTeams
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $teams = Team::query()->find($payload->pluckArrayValues('teams'));

        if ($teams !== null) {
            $teams->each(function (Team $team) use ($payload): void {
                if ($payload->getModel() instanceof User) {
                    $team->admins()->attach($payload->getModel()->admin->id);

                    return;
                }

                $team->admins()->attach($payload->getModel()->id);
            });
        }

        return $next($payload);
    }
}
